//+------------------------------------------------------------------+
//|                            Bollinger bands stop - EMA deviations |
//|                                                           mladen |
//| idea for Bollinger bands stop by igorad                          |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_width2 1
#property indicator_width4 1

//
//
//
//
//

extern string TimeFrame      = "Ccurrent time frame";
extern int    BandsPeriod    =  20;
extern double BandsDeviation = 2.0;
extern double MoneyRisk      = 1.0;
extern bool   Interpolate    = true;

//
//
//
//
//

double TrendU[];
double TrendUA[];
double TrendD[];
double TrendDA[];
double buffers[][5];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, TrendU);
   SetIndexBuffer(1, TrendUA); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2, TrendD);
   SetIndexBuffer(3, TrendDA); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);

   //
   //
   //
   //
   //

      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

   //
   //
   //
   //
   //

   IndicatorShortName(timeFrameToString(timeFrame)+" EMA deviations bands stop ("+BandsPeriod+","+DoubleToStr(BandsDeviation,2)+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { TrendU[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period()) { CalculateBBStops(limit);  return(0); }
         
   //
   //
   //
   //
   //
         
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         TrendU[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPeriod,BandsDeviation,MoneyRisk,0,y);
         TrendD[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPeriod,BandsDeviation,MoneyRisk,2,y);
         TrendUA[i] = EMPTY_VALUE;
         TrendDA[i] = EMPTY_VALUE;
            if (TrendU[i]!= EMPTY_VALUE && TrendU[i+1]==EMPTY_VALUE) TrendUA[i]=TrendU[i];
            if (TrendD[i]!= EMPTY_VALUE && TrendD[i+1]==EMPTY_VALUE) TrendDA[i]=TrendD[i];
               
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               if (TrendU[i]!=EMPTY_VALUE && TrendU[i+n]!=EMPTY_VALUE) TrendU[i+k] = TrendU[i] + (TrendU[i+n]-TrendU[i])*k/n;
               if (TrendD[i]!=EMPTY_VALUE && TrendD[i+n]!=EMPTY_VALUE) TrendD[i+k] = TrendD[i] + (TrendD[i+n]-TrendD[i])*k/n;
            }               
   }
   
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define trend 0
#define smax  1
#define smin  2
#define bmax  3
#define bmin  4

//
//
//
//
//

void CalculateBBStops(int limit)
{
   if (ArrayRange(buffers,0) != Bars) ArrayResize(buffers,Bars);
   int i,r;
 
   //
   //
   //
   //
   //
      
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      double ma     = iMA(NULL,0,BandsPeriod,0,MODE_SMA,PRICE_CLOSE,i);
      double stdDev = iEDev(Close[i],BandsPeriod,i)*BandsDeviation;

      //
      //
      //
      //
      //

      buffers[r][smax]  = ma+stdDev;
      buffers[r][smin]  = ma-stdDev;
      buffers[r][trend] = buffers[r-1][trend];

               if (Close[i]>buffers[r-1][smax]) buffers[r][trend]= 1;
               if (Close[i]<buffers[r-1][smin]) buffers[r][trend]=-1;

      if (buffers[r][trend]>0) buffers[r][smin] = MathMax(buffers[r][smin],buffers[r-1][smin]);
      if (buffers[r][trend]<0) buffers[r][smax] = MathMin(buffers[r][smax],buffers[r-1][smax]);
                               buffers[r][bmax] = buffers[r][smax]+(MoneyRisk-1.0)*stdDev;
                               buffers[r][bmin] = buffers[r][smin]-(MoneyRisk-1.0)*stdDev;
      if (buffers[r][trend]>0) buffers[r][bmin] = MathMax(buffers[r][bmin],buffers[r-1][bmin]);
      if (buffers[r][trend]<0) buffers[r][bmax] = MathMin(buffers[r][bmax],buffers[r-1][bmax]);

      //
      //
      //
      //
      //
         
      TrendU[i]  = EMPTY_VALUE;
      TrendUA[i] = EMPTY_VALUE;
      TrendD[i]  = EMPTY_VALUE;
      TrendDA[i] = EMPTY_VALUE;
         
      if (buffers[r][trend]>0) { TrendU[i] = buffers[r][bmin]; if (buffers[r][trend] != buffers[r-1][trend]) TrendUA[i] = TrendU[i];}
      else                     { TrendD[i] = buffers[r][bmax]; if (buffers[r][trend] != buffers[r-1][trend]) TrendDA[i] = TrendD[i];}
   }
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double edevWork[][2];
double iEDev(double price,double period, int i)
{
   if (ArrayRange(edevWork,0)!=Bars) ArrayResize(edevWork,Bars);
   
   int    r     = Bars-i-1;
   double alpha = 2.0/(1.0+period);
      
      edevWork[r][0] = edevWork[r-1][0]+alpha*(price      -edevWork[r-1][0]);
      edevWork[r][1] = edevWork[r-1][1]+alpha*(price*price-edevWork[r-1][1]);
         
   return(MathSqrt(period*(edevWork[r][1]-edevWork[r][0]*edevWork[r][0])/(period-1.0)));
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}